/** Tests selection sort of an array of 
    doubles. HJG 27/04/01 */
public class BubbleSortTest
{
    /** @param data an array of doubles
	@return sorted data array */
    public static void bubbleSort(double[] data)
    {
	boolean interchanged = true;
	int maxIndex = data.length-1;
	while (interchanged)
	{    
	    interchanged = false;
	    for (int i=0; i<maxIndex; i++)
	    {
		if (data[i]>data[i+1])
		{
		    double temp = data[i+1];
		    data[i+1] = data[i];
		    data[i] = temp;
		    interchanged=true;
		}
	    }
	    maxIndex--;
	}
    }

    public static void main(String[] args)
    {
	//	double[] data = {5., 0., -2.3, -0.3, 7.};
	//	double[] data = {5., 0., -2.3, -0.3, -7.};
        //	double[] data = {5.};
		int ndata = 50;
	double[] data = new double[ndata];
	for (int i = 0; i< data.length; i++)
	data[i]=ndata-i;

	System.out.println("Data array: ");
	for (int i = 0; i<data.length;i++) 
	    System.out.print(data[i] + " ");
	    System.out.println("");
	bubbleSort(data);
	System.out.println("Sorted data array");
	for (int i = 0; i<data.length;i++) 
	    System.out.print(data[i] + " ");
	    System.out.println("");
    }
}
